Subject: Re: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?

From: Andrea Corallo <[email-masked]>
Date: Tue, 7 Jul 2020 17:42:11 +0000 (UTC)

Mattias Engdegård <[email-masked]> writes:

> 7 juli 2020 kl. 18.24 skrev Andrea Corallo <[email-masked]>:
>
>> Sure I'm.  The native compiler does it already but I'm curious to see
>> how you do it at source level and how generic it is.
>
> Not very, but doing it at source level has some advantages since it can enable other source-level transformations.
> It's mainly a proof of concept -- for simplicity, it doesn't attempt to be overly clever in the face of loops or setq.
>
> One snag is that because Emacs inline functions (defsubst) are inlined
> as bytecode, they are usually not amenable to source optimisations. It
> is only when a defsubst is imported from a different .el file that has
> not yet been byte-compiled that it is integrated as source, and then
> the machinery in this patch will nicely propagate constant arguments
> into the body.

Well loops and setq without CFG IMO are likely to be difficult if not
impossible to optimize in a generic way.  But I agree that having a
simple optimization done earlier is always better given it can benefit
other ones.

  Andrea